﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 30
    /// </summary>
    public class CheckIndVarNotFixed : ElementChecker
    { 
        public CheckIndVarNotFixed() :base() { }

        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                bool result = !ind.fixedVars.Contains(ind.indVar);
                if (!result) ind.errors.Add(new Error(30));
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
